#!/usr/bin/perl

chdir "gr";
require "data.pl";
require "cookie.pl";
chdir "$ENV{HOME}/web/arimaa/games";

%c = CookieRead();
if ($c{sid}){
  %r = DataGetSessionRec($c{sid});
}

if ($c{"gameClient$r{id}"} eq "f2"){
  print "Location: /arimaa/gameroom/flShowGame.cgi?$ENV{QUERY_STRING}\n\n";
  exit;
}

if ($c{"gameClient$r{id}"} eq "f2h"){
  print "Location: /arimaa/gameroom/flShowGame.cgi?$ENV{QUERY_STRING}\n\n";
  exit;
}

if ($c{"gameClient$r{id}"} eq "f2d"){
  print "Location: /arimaa/gameroom/flShowGameDev.cgi?$ENV{QUERY_STRING}\n\n";
  exit;
}

use CGI ':cgi-lib';
&ReadParse();

$gid = $in{gid};

# Map g and s to w and b.
if ($in{s} eq "g"){ $in{s} = "w"; }
if ($in{s} eq "s"){ $in{s} = "b"; }

if (! $gid){
  print <<EOM;
Content-type: text/html

<html>
<form method=POST>
  Game ID : <input type=text name=gid> <input type=submit value="View">
</form>
</html>
EOM
  exit;
}

$curDir = `/bin/pwd`;
chomp $curDir;

chdir "/home/arimaa/web/arimaa/gameroom";

require "data.pl";

%g = DataGetPastGameRec("id=$gid");
%gb = DataGetPastGameBlobRec("id=$gid");

chdir "$curDir";


if (! $gb{movelist}){
  print <<EOM;
Content-type: text/html

<html>
<p>Game data not found for game id $gid
</html>
EOM
  exit;
}



# Give the HTML for the flash client
if ($in{client}){
  print "Content-type: text/html\n\n";
  print <<EOM;

<HTML>
<HEAD>
<!-- Meta http equivalent was here                        -->
<TITLE>ArimaaClient</TITLE>
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-cache">
</HEAD>
<BODY bgcolor="#d8d8f8" onLoad="top.resizeTo(750,750)">
<center>
<!-- URL's used in the movie-->
<!-- text used in the movie-->
<OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
 codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0"
 WIDTH="620" HEIGHT="520" id="ArimaaClient" ALIGN="">
  <PARAM NAME=movie VALUE="flashClient/ArimaaClient.swf?vf=showGame.cgi?gid=$in{gid}%26s=$in{s}%26m=$in{m}%26game=1&pf=flashClient/properties.txt"> 
  <PARAM NAME=quality VALUE=high> 
  <PARAM NAME=bgcolor VALUE=#DEDBFF> 
  <EMBED src="flashClient/ArimaaClient.swf?vf=showGame.cgi?gid=$in{gid}%26s=$in{s}%26m=$in{m}%26game=1&pf=flashClient/properties.txt" quality=high bgcolor=#DEDBFF  WIDTH="620" HEIGHT="520" NAME="ArimaaClient" ALIGN=""
 TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer">
  </EMBED>
</OBJECT>
</center>
</BODY>
</HTML>

EOM
  exit;
}


# Send the game properties to the flash client
if ($in{game}){

# Figure out the average move time per player
  if ($gb{events}){
    @ev = split(/\n/, $gb{events});
    foreach $ev (@ev){
      ($evTs, $evCom) = ($ev =~ m/^(\d+) (.*)$/);
      if ($ev =~ m/start move .* w$/){
        $evt[0] = $evTs;
      }
      $evMc = 0;
      ($evMc, $evMs) = ($ev =~ m/ move (\d+)(\w) /i);
      if ($evMc > 0){
        $mp = 2*$evMc - (($evMs eq "w")?1:0);
        $evt[$mp] = $evTs;
      }
    }
    if ($evt[0] eq ""){ $evt[0] = $evt[1]; }
    for($i=0;$i<=$#evt;$i++){
      if ($i>0){
        $d = $evt[$i] - $evt[$i-1];
        if ($i%2 == 1){ # whites move
          $wt += $d;
          $wc++;
        }
        else{
          $bt += $d;
          $bc++;
        }
      }
    }
    if ($wc > 0){ $wta = $wt/$wc; }
    if ($bc > 0){ $bta = $bt/$bc; }
    $avTime = sprintf("\nAverage move times: %s %.2fm, %s %.2fm\n", $g{wusername}, ($wta+0.5)/60, $g{busername}, ($bta+0.5)/60);
  }

  $gstime = gmtime($g{startts});
  $getime = gmtime($g{endts});
  $gb{chat} = "$g{wusername} ($g{wrating}) vs $g{busername} ($g{brating})\nPlayed $gstime GMT to $getime GMT\n$avTime";
  $gb{movelist} =~ s/ +\n/\n/gs;
  $gb{movelist} =~ s/\n\d+[wb]$//s;
  $gb{movelist} =~ s/\n/\%0d/gs;
  $gb{movelist} .= "%0d";

  if ($in{s} !~ m/^[wb]$/){ $in{s} = "w"; }

  

  print "Content-type: text/plain\n\n";
  print <<EOM;
mode=replay
&side=$in{s}
&title=Game $in{gid}
&wplayer=$g{wusername}
&bplayer=$g{busername}
&timecontrol=$g{timecontrol}
&result=$g{result}$g{termination}
&movelist=$gb{movelist}
&chat=$gb{chat}
EOM

  exit;
}


# Open another window for the flash client and close this window

print "Content-type: text/html\n\n";

print <<EOM;
<html>
  <head>
<meta HTTP-EQUIV="REFRESH" CONTENT="0; URL=showGame.cgi?gid=$in{gid}&s=$in{s}&client=1">
   <title>Open Game Window</title>
   <script language="JavaScript1.2">
<!--

function init(){

  open("showGame.cgi?gid=$in{gid}&s=$in{s}&client=1", "Replay$p{wplayer}vs$p{bplayer}", "toolbar=no,width=650,height=550,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no,status=yes");

  window.close();
}

// -->
    </script>
  </head>

  <body xonLoad="init()">
<pre>
</pre>
  </body>
</html>


EOM


exit;






